using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace EventHandlers
{

    public interface IListener
    {
        void Recieve(String message);
    }

    public interface IPublisher
    {
        void AddListener(IListener newListener);
        void Publish(String message);
    }




               

    class ChatPerson : IListener, IPublisher
    {
        public delegate void Send(string sentMessage);
        public event Send SendMessage = null;

        #region "Contructor"
        string myName;

        public ChatPerson(string name)
        {
            myName = name;
        }

        #endregion





        #region IListener Members

        void IListener.Recieve(string message)
        {
            Console.WriteLine(myName + " has received '" + message +"'!\n");
        }

        #endregion
                
        #region IPublisher Members

         public void Publish(string message)
        {
            SendMessage(message);
        }

        public void AddListener(IListener newListener)
        {
            SendMessage += newListener.Recieve;
        }


        #endregion
    }





}




